package com.gxwebsoft.common.system.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.common.system.service.IndustryService;
import com.gxwebsoft.common.system.entity.Industry;
import com.gxwebsoft.common.system.param.IndustryParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 企业行业记录表控制器
 *
 * @author 科技小王子
 * @since 2023-05-17 11:26:43
 */
@Api(tags = "企业行业记录表管理")
@RestController
@RequestMapping("/api/system/industry")
public class IndustryController extends BaseController {
    @Resource
    private IndustryService industryService;

    @PreAuthorize("hasAuthority('sys:industry:list')")
    @OperationLog
    @ApiOperation("分页查询企业行业记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<Industry>> page(IndustryParam param) {
        PageParam<Industry, IndustryParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(industryService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(industryService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('sys:industry:list')")
    @OperationLog
    @ApiOperation("查询全部企业行业记录表")
    @GetMapping()
    public ApiResult<List<Industry>> list(IndustryParam param) {
        PageParam<Industry, IndustryParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(industryService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(industryService.listRel(param));
    }

    @PreAuthorize("hasAuthority('sys:industry:list')")
    @OperationLog
    @ApiOperation("根据id查询企业行业记录表")
    @GetMapping("/{id}")
    public ApiResult<Industry> get(@PathVariable("id") Integer id) {
        return success(industryService.getById(id));
        // 使用关联查询
        //return success(industryService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('sys:industry:save')")
    @OperationLog
    @ApiOperation("添加企业行业记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Industry industry) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          industry.setUserId(loginUser.getUserId());
        }
        if (industryService.save(industry)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:industry:update')")
    @OperationLog
    @ApiOperation("修改企业行业记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Industry industry) {
        if (industryService.updateById(industry)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:industry:remove')")
    @OperationLog
    @ApiOperation("删除企业行业记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (industryService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('sys:industry:save')")
    @OperationLog
    @ApiOperation("批量添加企业行业记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Industry> list) {
        if (industryService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:industry:update')")
    @OperationLog
    @ApiOperation("批量修改企业行业记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Industry> batchParam) {
        if (batchParam.update(industryService, "industry_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:industry:remove')")
    @OperationLog
    @ApiOperation("批量删除企业行业记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (industryService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
